function [h0_coeff, h1_coeff] = analysis_filters3(A1, A2, A3, x, xn, M)
% compute the analysis filters from the lifting filters
% the first one add channel 1 to channel 0
% Copyright (c) 2006 Yi Chen

[a1_up, td] = upsampling_2d(double(subs(A1, x, xn)), [0,0], M);
[a2_up, td] = upsampling_2d(double(subs(A2, x, xn)), [0,0], M);
[a3_up, td] = upsampling_2d(double(subs(A3, x, xn)), [0,0], M);

h11 = conv2(a1_up, a2_up);
d11 = size(h11);
h11(d11(1)/2+0.5,d11(2)/2+0.5) = h11(d11(1)/2+0.5,d11(2)/2+0.5) + 1;
h10 = a2_up;
d10 = size(h10);
d = (d11 - d10)/2;
h1_coeff = h11;
h1_coeff(1+d(1):d11(1)-d(1), 1+d(2):d11(2)-d(2)) = h1_coeff(1+d(1):d11(1)-d(1), 1+d(2):d11(2)-d(2)) + h10;

h00 = conv2(a2_up, a3_up);
d00 = size(h00);
h00(d00(1)/2+0.5,d00(2)/2+0.5) = h00(d00(1)/2+0.5,d00(2)/2+0.5) + 1;
h01 = conv2(a1_up, conv2(a2_up, a3_up));
d01 = size(h01);
d = (d01 - size(a1_up))/2;
h01(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) = h01(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) + a1_up;
d = (d01 - size(a3_up))/2;
h01(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) = h01(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) + a3_up;
d = (d01 - d00)/2;
h0_coeff = h01;
h0_coeff(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) = h0_coeff(1+d(1):d01(1)-d(1), 1+d(2):d01(2)-d(2)) + h00;