function [h0_coeff, h1_coeff] = analysis_filters4(A1, A2, A3, A4, x, xn, M)
% compute the analysis filters from four lifting filters
% Copyright (c) 2006 Yi Chen

[a1_up, td] = upsampling_2d(double(subs(A1, x, xn)), [0,0], M);
[a2_up, td] = upsampling_2d(double(subs(A2, x, xn)), [0,0], M);
[a3_up, td] = upsampling_2d(double(subs(A3, x, xn)), [0,0], M);
[a4_up, td] = upsampling_2d(double(subs(A4, x, xn)), [0,0], M);

h1 = a1_up;
size1 = size(h1);
h1((size1(1)+1)/2,(size1(2)+1)/2) = h1((size1(1)+1)/2,(size1(2)+1)/2)+1;

h0 = conv2(h1, a2_up);
size0 = size(h0);
h0((size0(1)+1)/2,(size0(2)+1)/2) = h0((size0(1)+1)/2,(size0(2)+1)/2)+1;

h0temp = conv2(h0, a3_up);
d = (size(h0temp) - size(h1))/2;
h1_coeff = h0temp;
h1_coeff(1+d(1):size(h0temp,1)-d(1), 1+d(2):size(h0temp,2)-d(2)) = h1_coeff(1+d(1):size(h0temp,1)-d(1), 1+d(2):size(h0temp,2)-d(2)) + h1;

h1temp = conv2(h1_coeff, a4_up);
d = (size(h1temp) - size(h0))/2;
h0_coeff = h1temp;
h0_coeff(1+d(1):size(h1temp,1)-d(1), 1+d(2):size(h1temp,2)-d(2)) = h0_coeff(1+d(1):size(h1temp,1)-d(1), 1+d(2):size(h1temp,2)-d(2)) + h0;

[h0_coeff, td] = reduce_size(h0_coeff, [0,0], 1e-10);
[h1_coeff, td] = reduce_size(h1_coeff, [0,0], 1e-10);

